/*
	
*/

#pragma semicolon 1
#define PLUGIN_VERSION "1.0.0"
#define MINUTES_SESSION 0
#define MINUTES_SERV_OR_GLOB 1
#define CSGO_RED " \x07"
#define CSS_RED "\x07FF0000"

#include <sourcemod>
#include <autoexecconfig>	//https://github.com/Impact123/AutoExecConfig or https://forums.alliedmods.net/showthread.php?p=1862459
#include <sdkhooks>
#include <sdktools>
#include <togplaytimerecords>
#include <togsclantags>

//client variables								0								1								2				3
char ga_sSteamID[MAXPLAYERS + 1][4][65];	//AuthId_Steam2 [universe = 0], AuthId_Steam2 [universe = 1], AuthId_Steam3, AuthId_SteamID64
int gaa_iMinutes[MAXPLAYERS + 1][2];		//server playtime, current session playtime
bool ga_bValidAuth[MAXPLAYERS + 1];			//valid steam ID
int ga_iTimerStatus[MAXPLAYERS + 1] = {0, ...};		//0 = not loaded, 1 = loaded

bool g_bTPRLoaded = false;
bool g_bTCTLoaded = false;
bool g_bLateLoad;
Handle g_hDatabase = INVALID_HANDLE;
char g_sServerIP[64] = "";
int g_iDBLoaded = 0;
ConVar g_hGlobalTime;

ArrayList g_hSetupMinutes;
ArrayList g_hSetupTags;

public Plugin myinfo =
{
	name = "TOG 'Playtime Records' Clan Tags",
	author = "That One Guy",
	description = "Plugin that works with TOGs Playtime Records and TOGs Clan Tags to produce time-based clan tags setups with mysql.",
	version = PLUGIN_VERSION,
	url = "https://forums.alliedmods.net/member.php?u=188078"
}

public APLRes AskPluginLoad2(Handle hMyself, bool bLate, char[] sError, int err_max)
{
	g_bLateLoad = bLate;
	return APLRes_Success;
}

public void OnPluginStart()
{
	LoadTranslations("core.phrases");
	LoadTranslations("common.phrases");
	
	AutoExecConfig_SetFile("tpr_clantags");
	AutoExecConfig_CreateConVar("tpr_clantags_version", PLUGIN_VERSION, "TOG 'Playtime Records' Clan Tags: Version", FCVAR_NOTIFY|FCVAR_DONTRECORD);
	
	g_hGlobalTime = AutoExecConfig_CreateConVar("tpr_clantags_global", "1", "Use global time? (1 = yes, use total time from all servers in database, 0 = use time from this server only)", FCVAR_NONE, true, 0.0, true, 1.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	if(LibraryExists("togplaytimerecords"))
	{
		g_bTPRLoaded = true;
	}
	else
	{
		g_bTPRLoaded = false;
	}
	
	if(LibraryExists("togsclantags"))
	{
		if(!TOGsClanTags_UsingMysql())
		{
			SetFailState("In order to use this plugin, Togs Clan Tags must be using mysql setups!");
		}
		g_bTCTLoaded = true;
	}
	else
	{
		g_bTCTLoaded = false;
	}
	
	if(!g_bTPRLoaded || !g_bTCTLoaded)
	{
		CreateTimer(15.0, TimerCB_CheckForReqPlugins, _, TIMER_FLAG_NO_MAPCHANGE);
	}
	
	g_hSetupMinutes = new ArrayList();
	g_hSetupTags = new ArrayList(30);
	
	OnMapStart();
}

public Action TimerCB_CheckForReqPlugins(Handle hTimer)
{
	if(!g_bTPRLoaded)
	{
		SetFailState("Required plugin 'togplaytimerecords' is not running after 15.0 seconds from plugin loading!");
	}
	else if(!g_bTCTLoaded)
	{
		SetFailState("Required plugin 'togsclantags' is not running after 15.0 seconds from plugin loading!");
	}
}

/*
public void OnCVarChange(Handle hCVar, const char[] sOldValue, const char[] sNewValue)
{
	if(hCVar == g_hMinutesReqd)
	{
		g_iMinutesReqd = StringToInt(sNewValue);
	}
}*/

public void OnConfigsExecuted()
{
	GetServerIP();
	if(g_hDatabase == INVALID_HANDLE)
	{
		SetDBHandle();
	}
	
	if(g_bLateLoad)
	{
		//Log("test.log","calling CheckAllClients for late load");
		CheckAllClients();
	}
}

void GetServerIP()
{
	int a_iArray[4];
	int iLongIP = GetConVarInt(FindConVar("hostip"));
	a_iArray[0] = (iLongIP >> 24) & 0x000000FF;
	a_iArray[1] = (iLongIP >> 16) & 0x000000FF;
	a_iArray[2] = (iLongIP >> 8) & 0x000000FF;
	a_iArray[3] = iLongIP & 0x000000FF;
	Format(g_sServerIP, sizeof(g_sServerIP), "%d.%d.%d.%d:%i", a_iArray[0], a_iArray[1], a_iArray[2], a_iArray[3], GetConVarInt(FindConVar("hostport")));
}

void SetDBHandle()
{
	if(!g_iDBLoaded)	//if connection not in progress (allow if no connection only)
	{
		g_iDBLoaded = 1;
		if(g_hDatabase != INVALID_HANDLE)
		{
			CloseHandle(g_hDatabase);
			g_hDatabase = INVALID_HANDLE;
		}
		PrintToServer("Establishing database connection to togsclantags for tpr_clantags.");
		SQL_TConnect(SQLCallback_Connect, "togsclantags");
	}
}

public void SQLCallback_Connect(Handle hOwner, Handle hHndl, const char[] sError, any data)
{
	if(hHndl == INVALID_HANDLE)
	{
		SetFailState("Error connecting to togsclantags database: %s", sError);
	}
	else
	{
		g_hDatabase = hHndl;
		g_iDBLoaded = 2;
		PrintToServer("Database connection established to togsclantags for tpr_clantags! Checking any valid clients...");
		//Log("test.log","calling CheckAllClients for SQLCallback_Connect");
		CheckAllClients();
	}
}

public void OnMapStart()
{
	LoadCfg();
}

void LoadCfg()
{
	g_hSetupMinutes.Clear();
	g_hSetupTags.Clear();
	
	char g_sCfgPath[PLATFORM_MAX_PATH], sBuffer[30];
	BuildPath(Path_SM, g_sCfgPath, sizeof(g_sCfgPath), "configs/tpr_clantags.cfg");
	
	KeyValues hKeyValues = null;
	hKeyValues = new KeyValues("Setups");
	
	if(!FileExists(g_sCfgPath))
	{
		SetFailState("Configuration file %s not found!", g_sCfgPath);
		return;
	}

	if(!hKeyValues.ImportFromFile(g_sCfgPath))
	{
		SetFailState("Improper structure for configuration file %s!", g_sCfgPath);
		return;
	}
	
	if(hKeyValues.GotoFirstSubKey(true))
	{
		do
		{
			int iMinReq = hKeyValues.GetNum("minutes", 0);
			if(iMinReq >= 0)
			{
				g_hSetupMinutes.Push(hKeyValues.GetNum("minutes", 0));
				hKeyValues.GetString("clantag", sBuffer, sizeof(sBuffer), "[NOT SET] ");
				g_hSetupTags.PushString(sBuffer);
			}
		} while(hKeyValues.GotoNextKey(false));
		hKeyValues.GoBack();
	}
	else
	{
		SetFailState("Can't find first subkey in configuration file %s!", g_sCfgPath);
		return;
	}
	delete hKeyValues;
}

void CheckAllClients()
{
	//Log("test.log","checking all clients for time based clan tags...");
	if(g_bTCTLoaded && g_bTPRLoaded && (g_iDBLoaded == 2))
	{
		//Log("test.log","checks passed in CheckAllClients - looping clients now...");
		for(int i = 1; i <= MaxClients; i++)
		{
			if(IsValidClient(i))
			{
				ResetClientVariables(i);
				GetSteamID(i);
				if(StrContains(ga_sSteamID[i][0], "STEAM_", true) == -1) //if ID is invalid
				{
					CreateTimer(10.0, RefreshSteamID, GetClientUserId(i), TIMER_FLAG_NO_MAPCHANGE);
				}
				else
				{
					ga_bValidAuth[i] = true;
					GetTimes(i);
				}
			}
		}
	}
	else
	{
		//Log("test.log","checks NOT passed in CheckAllClients");
	}
}

public void OnLibraryRemoved(const char[] sName)
{
	if(StrEqual(sName, "togplaytimerecords"))
	{
		LogError("Required plugin 'togplaytimerecords' is not running!");
		g_bTPRLoaded = false;
	}
	else if(StrEqual(sName, "togsclantags"))
	{
		LogError("Required plugin 'togsclantags' is not running!");
		g_bTCTLoaded = false;
	}
}

public void OnLibraryAdded(const char[] sName)
{
	if(StrEqual(sName, "togplaytimerecords"))
	{
		g_bTPRLoaded = true;
		//Log("test.log","calling CheckAllClients for togplaytimerecords library loading");
		CheckAllClients();
	}
	else if(StrEqual(sName, "togsclantags"))
	{
		if(!TOGsClanTags_UsingMysql())
		{
			SetFailState("In order to use this plugin, Togs Clan Tags must be using mysql setups!");
		}
		g_bTCTLoaded = true;
		//Log("test.log","calling CheckAllClients for togsclantags library loading");
		CheckAllClients();
	}
	
}

public void OnClientConnected(int client)
{
	ResetClientVariables(client);
}

public void OnClientDisconnect(int client)
{
	ResetClientVariables(client);
}

void ResetClientVariables(int client)
{
	ga_sSteamID[client][0] = "";
	ga_sSteamID[client][1] = "";
	ga_sSteamID[client][2] = "";
	ga_sSteamID[client][3] = "";
	ga_bValidAuth[client] = false;
	gaa_iMinutes[client][MINUTES_SERV_OR_GLOB] = -1;
	gaa_iMinutes[client][MINUTES_SESSION] = -1;
	ga_iTimerStatus[client] = 0;
}

public void OnClientPostAdminCheck(int client)
{
	GetSteamID(client);
	if(StrContains(ga_sSteamID[client][0], "STEAM_", true) == -1) //still invalid - retry again
	{
		CreateTimer(10.0, RefreshSteamID, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
	}
	else
	{
		ga_bValidAuth[client] = true;
		//Log("test.log","OnClientPostAdminCheck GetTimes: %L", client);
		//GetTimes(client);
	}
}

public Action RefreshSteamID(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!IsValidClient(client))
	{
		return;
	}
	GetSteamID(client);
	if(StrContains(ga_sSteamID[client][0], "STEAM_", true) == -1) //still invalid - retry again
	{
		CreateTimer(10.0, RefreshSteamID, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
	}
	else
	{
		ga_bValidAuth[client] = true;
		//Log("test.log","RefreshSteamID GetTimes: %L", client);
		GetTimes(client);
	}
}

public int TPRClientTimesLoaded(int client)
{
	//Log("test.log","TPRClientTimesLoaded GetTimes: %L", client);
	GetTimes(client);
}

void GetTimes(int client)
{
	//Log("test.log", "Gettimes: %L", client);
	if(g_bTPRLoaded && g_bTCTLoaded && (g_iDBLoaded == 2))
	{
		//Log("test.log", "Gettimes: %L (2)", client);
		if(g_hGlobalTime.BoolValue)
		{
			gaa_iMinutes[client][MINUTES_SERV_OR_GLOB] = tpr_GlobalPlayTime(client);	//Global time playing on teams
		}
		else
		{
			gaa_iMinutes[client][MINUTES_SERV_OR_GLOB] = tpr_ServerPlayTime(client);	//Server time playing on teams
		}
		gaa_iMinutes[client][MINUTES_SESSION] = tpr_CurrentPlayTime(client);	//Time playing on teams for current session
		//Log("test.log", "Gettimes: %L ; MINUTES_SERV_OR_GLOB: %i ; MINUTES_SESSION: %i", client, gaa_iMinutes[client][MINUTES_SERV_OR_GLOB], gaa_iMinutes[client][MINUTES_SESSION]);
		if((tpr_IsLoaded(client) >= 1) && ga_bValidAuth[client])
		{
			//Log("test.log", "Gettimes: %L (3)", client);
			ga_iTimerStatus[client] = 1;
			if(!CheckCommandAccess(client, "sm_not_a_command", ADMFLAG_ROOT, true))
			{
				//Log("test.log", "Gettimes: %L (4)", client);
				//CreateTimer(60.0, TimerCB_CheckTime, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE|TIMER_REPEAT);
				CheckForFlags(client);
			}
		}
	}
}

/*public Action TimerCB_CheckTime(Handle hTimer, any iUserID)
{
	int client = GetClientOfUserId(iUserID);
	if(!IsValidClient(client))
	{
		return Plugin_Stop;
	}
	
	if(ga_iTimerStatus[client] != 1)
	{
		return Plugin_Stop;
	}
	
	if(CheckCommandAccess(client, "sm_not_a_command", ADMFLAG_ROOT, true))
	{
		return Plugin_Stop;
	}
	Log("test.log","TimerCB_CheckTime GetTimes: %L", client);
	GetTimes(client);
	
	return Plugin_Continue;
}*/

void CheckForFlags(int client)
{
	if(IsValidClient(client))
	{
		//Log("test.log", "CheckForFlags: %L (1)", client);
		if(g_hSetupMinutes.Length)
		{
			//Log("test.log", "CheckForFlags: %L (2)", client);
			for(int i = 0; i < g_hSetupMinutes.Length; i++)
			{
				//Log("test.log", "CheckForFlags: %L ; inside loop: %i", client, i);
				int iMinReq = g_hSetupMinutes.Get(i);
				if((gaa_iMinutes[client][MINUTES_SERV_OR_GLOB] + gaa_iMinutes[client][MINUTES_SESSION]) > iMinReq)
				{
					//Log("test.log", "CheckForFlags: %L passed check in loop: %i", client, i);
					char sBuffer[30];
					g_hSetupTags.GetString(i, sBuffer, sizeof(sBuffer));
					GiveTags(client, sBuffer);
					return;
				}
			}
		}
	}
}

void GiveTags(int client, char[] sTags)
{
	//Log("test.log", "GiveTags: %L (1)", client);
	char sQuery[700];
	Format(sQuery, sizeof(sQuery), "SELECT ignore_setup,dont_remove,tagtext,setup_type FROM togsclantags_setups WHERE ((server_ip LIKE '%%%s%%') OR (server_ip = '') OR (server_ip IS NULL)) AND (enable_setup = 1) AND ((setup_type LIKE '%%%s%%') OR (setup_type LIKE '%%%s%%') OR (setup_type LIKE '%%%s%%') OR (setup_type LIKE '%%%s%%'))", g_sServerIP, ga_sSteamID[client][0], ga_sSteamID[client][1], ga_sSteamID[client][2], ga_sSteamID[client][3]);
	DataPack hPack = new DataPack();
	hPack.WriteCell(GetClientUserId(client));
	hPack.WriteString(sTags);
	hPack.Reset();
	//Log("test.log", "GiveTags: %L ; Query: %s; tag: %s", client, sQuery, sTags);
	SQL_TQuery(g_hDatabase, SQLCB_CheckPlayerSQL, sQuery, hPack);
}

public void SQLCB_CheckPlayerSQL(Handle hOwner, Handle hHndl, const char[] sError, any hPack /*DataPack hPack*/)
{
	//Log("test.log", "SQLCB_CheckPlayerSQL: (1)");
	if(hHndl == INVALID_HANDLE)
	{
		LogError("Error on checking for player setups in database: %s", sError);
		CloseHandle(hPack);
		return;
	}
	//Log("test.log", "SQLCB_CheckPlayerSQL:(2)");
	char sTag[30];
	int iUserID = ReadPackCell(hPack);	//hPack.ReadCell();
	int client = GetClientOfUserId(iUserID);
	ReadPackString(hPack, sTag, sizeof(sTag));	//hPack.ReadString(sTag, sizeof(sTag));
	CloseHandle(hPack);
	
	if(!IsValidClient(client))
	{
		return;
	}
	//Log("test.log", "SQLCB_CheckPlayerSQL: %L (3)", client);
	bool bInsert = true;
	if(SQL_GetRowCount(hHndl) > 0)
	{
		//Log("test.log", "SQLCB_CheckPlayerSQL: %L (4)", client);
		while(SQL_FetchRow(hHndl))
		{
			//Log("test.log", "SQLCB_CheckPlayerSQL: %L (5)", client);
			/*	
				`id` INT(20) NOT NULL AUTO_INCREMENT,
				`setup_type` VARCHAR(150) NOT NULL DEFAULT 'public',	- BOT, Steam id, flags
				`enable_setup` INT(1) NOT NULL DEFAULT 1,
				`exclude_setup` INT(1) NULL DEFAULT 0,					- Block tags being used under a certain setup
				`ignore_setup` INT(1) NULL DEFAULT 0,					- allows player to escape having a setup
				`tagtext` VARCHAR(150) NULL DEFAULT '',
				`server_ip` VARCHAR(300) NULL DEFAULT '',
				`setup_order` INT(10) NULL DEFAULT 0
				`dont_remove` INT(2) NULL DEFAULT 1
				
					0			1		  2	       3
				ignore_setup,dont_remove,tagtext,setup_type
			*/
			if(SQL_FetchInt(hHndl, 0) || SQL_FetchInt(hHndl, 1))
			{
				//Log("test.log", "SQLCB_CheckPlayerSQL: %L (6). Dont remove or ignore setup", client);
				bInsert = false;
				break;
			}
			else
			{
				//Log("test.log", "SQLCB_CheckPlayerSQL: %L (7). safe to remove", client);
				char sBuffer[50];
				SQL_FetchString(hHndl, 2, sBuffer, sizeof(sBuffer));
				if(StrEqual(sBuffer, sTag, false))	//setup already in DB
				{
					//Log("test.log", "SQLCB_CheckPlayerSQL: %L (7-2). safe to remove but match already in DB", client);
					bInsert = false;
					break;
				}
			}
		}
	}
	else	//not in DB - insert
	{
		//Log("test.log", "SQLCB_CheckPlayerSQL: %L (8)", client);
		char sQuery[300];
		if(g_hGlobalTime.BoolValue)
		{
			Format(sQuery, sizeof(sQuery), "INSERT INTO togsclantags_setups (setup_type, enable_setup, tagtext, setup_order, dont_remove) VALUES('%s', 1, '%s', 1, 0)", ga_sSteamID[client][2], sTag);
		}
		else
		{
			Format(sQuery, sizeof(sQuery), "INSERT INTO togsclantags_setups (setup_type, enable_setup, tagtext, server_ip, setup_order, dont_remove) VALUES('%s', 1, '%s', '%s', 1, 0)", ga_sSteamID[client][2], sTag, g_sServerIP);
		}
		LogMessage("Adding new player to clantags database for having %i minutes. Query: %s", gaa_iMinutes[client][MINUTES_SERV_OR_GLOB] + gaa_iMinutes[client][MINUTES_SESSION], sQuery);
		//Log("test.log", "SQLCB_CheckPlayerSQL: %L (9); query: %s", client, sQuery);
		SQL_TQuery(g_hDatabase, SQLCB_InsertPlayer, sQuery, iUserID);
		return;
	}
	
	//already in DB if here in code due to return above
	if(bInsert)
	{
		//Log("test.log", "SQLCB_CheckPlayerSQL: %L (9)", client);
		//remove setup in DB, then add in CB
		char sQuery[700];
		DataPack hDataPack = new DataPack();
		hDataPack.WriteCell(iUserID);
		hDataPack.WriteString(sTag);
		hDataPack.Reset();
		if(g_hGlobalTime.BoolValue)
		{
			Format(sQuery, sizeof(sQuery), "DELETE FROM togsclantags_setups WHERE ((server_ip = '%s') OR (server_ip = '') OR (server_ip IS NULL)) AND (enable_setup = 1) AND (dont_remove = 0) AND ((setup_type = '%s') OR (setup_type = '%s') OR (setup_type = '%s') OR (setup_type = '%s'))", g_sServerIP, ga_sSteamID[client][0], ga_sSteamID[client][1], ga_sSteamID[client][2], ga_sSteamID[client][3]);
		}
		else
		{
			Format(sQuery, sizeof(sQuery), "DELETE FROM togsclantags_setups WHERE (server_ip = '%s') AND (enable_setup = 1) AND (dont_remove = 0) AND ((setup_type = '%s') OR (setup_type = '%s') OR (setup_type = '%s') OR (setup_type = '%s'))", g_sServerIP, ga_sSteamID[client][0], ga_sSteamID[client][1], ga_sSteamID[client][2], ga_sSteamID[client][3]);
		}
		LogMessage("Removing setups for player to add new setup. Query: %s", sQuery);
		//Log("test.log", "SQLCB_CheckPlayerSQL: %L (10); qUERY: %S", client, sQuery);
		SQL_TQuery(g_hDatabase, SQLCB_RemovePlayer, sQuery, hDataPack);
	}
}

public void SQLCB_RemovePlayer(Handle hOwner, Handle hHndl, const char[] sError, DataPack hPack)
{
	if(hHndl == INVALID_HANDLE)
	{
		LogError("Error removing player setups from database: %s", sError);
		CloseHandle(hPack);
		return;
	}
	//Log("test.log", "SQLCB_RemovePlayer: (1)");
	char sTag[30];
	int iUserID = ReadPackCell(hPack);	//hPack.ReadCell();
	int client = GetClientOfUserId(iUserID);
	ReadPackString(hPack, sTag, sizeof(sTag));	//hPack.ReadString(sTag, sizeof(sTag));
	CloseHandle(hPack);
	
	if(!IsValidClient(client))
	{
		LogMessage("Note: Client disconnected after setup was removed and before replacing with new setup! Setup will have to be added next time player connects.");
		return;
	}
	//Log("test.log", "SQLCB_RemovePlayer: %L (2)", client);
	char sQuery[300];
	if(g_hGlobalTime.BoolValue)
	{
		Format(sQuery, sizeof(sQuery), "INSERT INTO togsclantags_setups (setup_type, enable_setup, tagtext, setup_order, dont_remove) VALUES('%s', 1, '%s', 1, 0)", ga_sSteamID[client][2], sTag);
	}
	else
	{
		Format(sQuery, sizeof(sQuery), "INSERT INTO togsclantags_setups (setup_type, enable_setup, tagtext, server_ip, setup_order, dont_remove) VALUES('%s', 1, '%s', '%s', 1, 0)", ga_sSteamID[client][2], sTag, g_sServerIP);
	}
	LogMessage("Updating player setup in clantags database for having %i minutes. Query: %s", gaa_iMinutes[client][MINUTES_SERV_OR_GLOB] + gaa_iMinutes[client][MINUTES_SESSION], sQuery);
	//Log("test.log", "SQLCB_RemovePlayer: %L (3); QUERY: %s", client,sQuery);
	SQL_TQuery(g_hDatabase, SQLCB_InsertPlayer, sQuery, GetClientUserId(client));
}

public void SQLCB_InsertPlayer(Handle hOwner, Handle hHndl, const char[] sError, any iUserID)
{
	//Log("test.log", "SQLCB_InsertPlayer (1)");
	if(hHndl == INVALID_HANDLE)
	{
		SetFailState("Error inserting player into database: %s", sError);
	}
	
	int client = GetClientOfUserId(iUserID);
	if(IsValidClient(iUserID))
	{
		PrintToChat(client, "Your time playing on the record has earned you a new tag! Tags will be refreshed for the server in a few seconds...");
	}
	//Log("test.log", "SQLCB_InsertPlayer (2)");
	CreateTimer(3.0, TimerCB_ReloadTCT);
}

public Action TimerCB_ReloadTCT(Handle hTimer)
{
	//Log("test.log", "TimerCB_ReloadTCT (1)");
	TOGsClanTags_Reload();
}

bool IsValidClient(int client, bool bAllowBots = false)
{
	if(!(1 <= client <= MaxClients) || !IsClientInGame(client) || (IsFakeClient(client) && !bAllowBots) || IsClientSourceTV(client) || IsClientReplay(client))
	{
		return false;
	}
	return true;
}

void GetSteamID(int client)
{
	GetClientAuthId(client, AuthId_Steam2, ga_sSteamID[client][0], 65);
	ReplaceString(ga_sSteamID[client][0], 65, "STEAM_1", "STEAM_0", false);
	GetClientAuthId(client, AuthId_Steam2, ga_sSteamID[client][1], 65);
	ReplaceString(ga_sSteamID[client][1], 65, "STEAM_0", "STEAM_1", false);
	GetClientAuthId(client, AuthId_Steam3, ga_sSteamID[client][2], 65);
	GetClientAuthId(client, AuthId_SteamID64, ga_sSteamID[client][3], 65);
}

stock void Log(char[] sPath, const char[] sMsg, any ...)	// TOG logging function - path is relative to logs folder.
{
	char sLogFilePath[PLATFORM_MAX_PATH], sFormattedMsg[3000];
	BuildPath(Path_SM, sLogFilePath, sizeof(sLogFilePath), "logs/%s", sPath);
	VFormat(sFormattedMsg, sizeof(sFormattedMsg), sMsg, 3);
	if(!StrEqual(sFormattedMsg, "", false))
	{
		LogToFileEx(sLogFilePath, "%s", sFormattedMsg);
	}
}

/*
CHANGELOG:
	1.0.0
		- Plugin created.
	1.0.1
		- Fixed missing conversion from userid to client index in one of the timers. Added temporary logging.
		- Removed repeat timer - new tags applied on map change or on !mytime command.
*/